export declare abstract class FixSizeArray<I> {
    protected len: number;
    protected list: I[];
    protected _max: number;
    constructor(list: I[]);
    remove(index: number): void;
    init(size?: number): void;
    item(index: number): I;
    size(): number;
    readonly max: number;
}
export declare class Float32ItemArray<I> extends FixSizeArray<I> {
    constructor(itemSize: number, listSize: number, factory: ItemFactory<I>);
}
export interface ItemFactory<I> {
    createInstance(index: number, typedArray: any): I;
}
