"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Float32ItemArray = exports.FixSizeArray = undefined;

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FixSizeArray = exports.FixSizeArray = function () {
    function FixSizeArray(list) {
        (0, _classCallCheck3.default)(this, FixSizeArray);

        this.list = list;
        this._max = list.length;
        this.len = 0;
    }

    (0, _createClass3.default)(FixSizeArray, [{
        key: "remove",
        value: function remove(index) {
            if (index < 0 || index >= this.len) {
                return;
            }
            var removed = this.list[index];
            this.len = this.len - 1 | 0;
            var i = index + 1 | 0;
            while (i < this._max) {
                this.list[i - 1] = this.list[i];
                i = i + 1 | 0;
            }
            this.list[i - 1] = removed;
        }
    }, {
        key: "init",
        value: function init() {
            var size = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

            this.len = size;
        }
    }, {
        key: "item",
        value: function item(index) {
            return this.list[index];
        }
    }, {
        key: "size",
        value: function size() {
            return this.len;
        }
    }, {
        key: "max",
        get: function get() {
            return this._max;
        }
    }]);
    return FixSizeArray;
}();

var Float32ItemArray = exports.Float32ItemArray = function (_FixSizeArray) {
    (0, _inherits3.default)(Float32ItemArray, _FixSizeArray);

    function Float32ItemArray(itemSize, listSize, factory) {
        (0, _classCallCheck3.default)(this, Float32ItemArray);

        var array = new Float32Array(itemSize * listSize);
        var i = 0 | 0;
        var list = [];
        while (i < listSize) {
            list.push(factory.createInstance(i, array));
            i = i + 1 | 0;
        }
        return (0, _possibleConstructorReturn3.default)(this, (Float32ItemArray.__proto__ || Object.getPrototypeOf(Float32ItemArray)).call(this, list));
    }

    return Float32ItemArray;
}(FixSizeArray);
//# sourceMappingURL=FixSizeArray.js.map
