import * as drawchat from "@s2study/draw-api";
import DrawchatCanvas = drawchat.editor.DrawEditorCanvas;
import TextTransaction = drawchat.updater.TextTransaction;
import DrawchatViewer = drawchat.viewer.DrawchatViewer;
import { EditorProperties } from "./EditorProperties";
export declare class ModeText implements DrawchatCanvas {
    private viewer;
    private tran;
    private prop;
    constructor(viewer: DrawchatViewer, tran: TextTransaction, prop: EditorProperties);
    private text;
    private pointX;
    private pointY;
    private time;
    private waiting;
    touchStart(x: number, y: number): void;
    touchMove(x: number, y: number): void;
    touchEnd(x: number, y: number): void;
    setText(text: string): void;
    private setWait();
    private drawText();
    backward(): void;
    forward(): void;
}
