import * as emitter from "eventemitter3";
import { EditorProperties } from "./EditorProperties";
export declare class EditorEventDispatchers {
    private _changeProperties;
    readonly changeProperties: EventDispatcher<EditorProperties>;
    private _changeMode;
    readonly changeMode: EventDispatcher<number>;
    private _changeCurrentLayer;
    readonly changeCurrentLayer: EventDispatcher<number>;
    private _update;
    readonly update: EventDispatcher<any>;
    constructor(eventEmitter: emitter.EventEmitter);
}
export declare class EventDispatcher<V> {
    private eventName;
    private emitter3;
    constructor(emitter3: emitter.EventEmitter, eventName: string);
    dispatch(val: V): void;
}
