import * as drawchat from "@s2study/draw-api";
import DrawchatCanvas = drawchat.editor.DrawEditorCanvas;
import TransformTransaction = drawchat.updater.TransformTransaction;
export declare class ModeHandTool implements DrawchatCanvas {
    private tran;
    constructor(tran: TransformTransaction);
    private time;
    sPointX: number;
    sPointY: number;
    private wPointX;
    private wPointY;
    private waiting;
    touchStart(x: number, y: number): void;
    touchMove(x: number, y: number): void;
    touchEnd(x: number, y: number): void;
    private setWait();
    private setTranslate(x, y);
    setText(text: string): void;
    backward(): void;
}
