"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ModeStroke = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _AbstractModeStroke2 = require("./AbstractModeStroke");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ModeStroke = exports.ModeStroke = function (_AbstractModeStroke) {
    (0, _inherits3.default)(ModeStroke, _AbstractModeStroke);

    function ModeStroke(viewer, tran, prop) {
        (0, _classCallCheck3.default)(this, ModeStroke);

        var _this = (0, _possibleConstructorReturn3.default)(this, (ModeStroke.__proto__ || Object.getPrototypeOf(ModeStroke)).call(this, viewer, tran, prop));

        _this.prop = prop;
        return _this;
    }

    (0, _createClass3.default)(ModeStroke, [{
        key: "setProperty",
        value: function setProperty(tran) {
            tran.setStrokeColor("rgba(" + this.prop.color.r + "," + this.prop.color.g + "," + this.prop.color.b + "," + this.prop.alpha + ")");
            tran.setStrokeStyle(this.prop.thickness);
        }
    }, {
        key: "setCommitProperty",
        value: function setCommitProperty(tran) {}
    }]);
    return ModeStroke;
}(_AbstractModeStroke2.AbstractModeStroke);
//# sourceMappingURL=ModeStroke.js.map
