import { Float32ItemArray } from "./FixSizeArray";
export interface Point {
    x: number;
    y: number;
}
/**
 * 固定長サイズのリスト
 */
export declare class PointList extends Float32ItemArray<Point> {
    constructor(size: number);
    push(x?: number, y?: number): Point;
    set(index: number, x: number, y: number): Point;
}
