import { PointList } from "./PointArray";
/**
 * ２次ベジェスプライン曲線をプロットするクラス
 * コードは以下のサイトから引用
 *
 * http://hakuhin.jp/as/curve.html#CURVE_04
 */
export declare class SplinePlotter {
    /**
     * プロット数
     */
    private optCount;
    private _A;
    private _B;
    private _C;
    private l;
    private result;
    private input;
    constructor(cashSize?: number, optCount?: number);
    readonly resultList: PointList;
    readonly inputList: PointList;
    /**
     * スプライン曲線描画用の座標を取得します。
     */
    calc(): void;
    private convertNaN(num);
}
